/**************************************************************************
 *
 * SOURCE FILE NAME = ATAPIEXT.H
 *
 * DESCRIPTION : Data External References
 *
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = 1.0
 *
 * DATE
 *
 * DESCRIPTION :
 *
 * Purpose:
 *
 *
 * CHANGE ACTIVITY =
 *   DATE      FLAG        DEFECT  CHANGE DESCRIPTION
 *   --------  ----------  ------  --------------------------------------
 *   08/22/94  V@93531     93531   1) Suspend/Resume logic passes IRQ handler
 *                                 address. 2) DRQ polling is not valid while
 *                                 BSY bit set.
 *   04/03/95  @V117508    117508  Add #defines to include MCA version of
 *                                 driver.
 *   04/05/96  @V151168            Merged warm dock/swap code.
 *   05/24/96  @V155162            Thinkpad docking/swapping IDE update.
 ***************************************************************************/

 #include "rmbase.h"

/*-------------------------------------------------------------------*/
/*                                                                   */
/*      Static Data                                                  */
/*                                                                   */
/*                                                                   */
/*-------------------------------------------------------------------*/


 extern ACBPTRS      ACBPtrs[MAX_ADAPTERS];
 extern PFN          Device_Help;
 extern PFN          RM_Help;
 extern PFN          RM_Help0;
 extern PFN          RM_Help3;
 extern USHORT       ADDHandle;
 extern USHORT       cAdapters;
 extern USHORT       cUnits;
 extern USHORT       InitActive;
 extern USHORT       InitIOComplete;
 extern USHORT       MachineID;
 extern USHORT       Calibrate;
 extern ULONG        WaitDRQCount;
 extern ULONG        WaitBSYCount;                                   /*V@93531*/
 extern ULONG        CheckReadyCount;
 extern ULONG        IODelayCount;
 extern ULONG        ElapsedTimerHandle;
 extern PULONG       pNestedIntCount;
 extern USHORT       cInt;
 extern UCHAR        AdapterName[17];  /* Adapter Name ASCIIZ string */
 extern UCHAR        BeginInitData;
 extern LIN          plDataSeg;
 extern LIN          plSwapCode;
 extern USHORT       SwapCodeLen;
 extern USHORT       ADDLockCount;
 extern LIN          plADDLockHandle;
 extern UCHAR        ADDLockHandle[12];
 extern USHORT       ComPort;
 extern UCHAR        INTTIMEOUTMSG[];
 extern USHORT       AddSenseDataMap[];
 extern USHORT       MaxAddSenseDataEntry;
 extern USHORT       cResets;
 extern USHORT       LevelInterrupt;                               /*@V117508*/

 extern USHORT			AdaptersForced;                               /*@V151168*/
 extern SCSI_REQSENSE_DATA no_audio_status;                        /*@V151168*/
 extern SCSI_REQSENSE_DATA medium_not_present;                     /*@V151168*/
 extern SCSI_REQSENSE_DATA invalid_field_in_cmd_pkt;               /*@V151168*/
 extern SCSI_REQSENSE_DATA invalid_cmd_op_code;                    /*@V151168*/
 extern SCSI_INQDATA       inquiry_data;                           /*@V151168*/
 extern UCHAR              mode_sense_10_page_cap[];               /*@V151168*/
 extern IDENTIFYDATA       atapi_identify_data;                    /*@V151168*/


/*-------------------------------------------------------------------*/
/*                                                                   */
/*      Area to build Control Blocks                                 */
/*                                                                   */
/*                                                                   */
/*-------------------------------------------------------------------*/


 extern UCHAR TimerPool[];

 extern USHORT       ACBPoolAvail;
 extern NPBYTE       npACBPool;
 extern UCHAR        ACBPool[];


/*-------------------------------------------------------------------*/
/*                                                                   */
/*      Initialization Data                                          */
/*                                                                   */
/*                                                                   */
/*-------------------------------------------------------------------*/


 extern ATBL                   AdapterTable[];
 extern ULONG                  CalibrateTimerHandle;
 extern ULONG                  CallWorkerSync;
 extern ULONG                  CallWorker;
 extern BOOL                   Verbose;
 extern BOOL                   Installed;
 extern SCATGATENTRY           SenseDataSGList;
 extern SCATGATENTRY           IdentifySGList;
 extern CHAR                   MatshitaID[];                        /*@V155162*/
 extern CHAR                   Nec01ID[];                           /*@V155162*/
 extern CHAR                   Nec01FWID[];                         /*@V155162*/
 extern CHAR                   Nec02ID[];                           /*@V155162*/
 extern CHAR                   BlankSerial[];                       /*@V155162*/
 extern PDDD_PARM_LIST         pDDD_Parm_List;
 extern UCHAR                  TimersCalibrated;
 extern IDCTABLE               DDTable;
 extern MSGTABLE               InitMsg;
 extern NPSZ                   AdptMsgs[];
 extern NPSZ                   UnitMsgs[];
 extern NPSZ                   ProtocolTypeMsgs[];
 extern NPSZ                   DeviceTypeMsgs[];
 extern NPSZ                   CMDDRQTypeMsgs[];
 extern NPSZ                   MsgSMSOn;
 extern NPSZ                   MsgLBAOn;
 extern NPSZ                   MsgNull;
 extern UCHAR                  ParmErrMsg[];
 extern UCHAR                  UninstallMsg[];
 extern UCHAR                  VersionMsg[];
 extern UCHAR                  DevEqualsMsg[];
 extern UCHAR                  ScratchBuf[SCRATCH_BUF_SIZE];
 extern UCHAR                  ScratchBuf1[SCRATCH_BUF_SIZE];
 extern UCHAR                  SenseDataBuf[];
 extern ULONG                  ppSenseDataBuf;
 extern IORB_ADAPTER_PASSTHRU  InitIORB;

 extern UCHAR                  IORBSTR[];
 extern UCHAR                  IORBATAPIPKT[];
 extern UCHAR                  StringBuffer[];
 extern UCHAR                  INTStringBuffer[];

 extern                        DiskDDHeader;
 extern HDRIVER                hDriver;
 extern UCHAR                  SearchKeytxt[];
 extern DEVICESTRUCT           DevStruct;
 extern DRIVERSTRUCT           DriverStruct;
 extern UCHAR                  DrvrNameTxt[];
 extern USHORT                 DrvrNameSize;

 extern BOOL                   Force;                               /*@V151168*/
