/**************************************************************************
 *
 * SOURCE FILE NAME = FLTSTRAT.C
 *
 * DESCRIPTIVE NAME = Strategy 1 interface for CDROM Filter Driver
 *
 * Copyright : COPYRIGHT IBM CORPORATION, 1991, 1992
 *             LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
 *             REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
 *             RESTRICTED MATERIALS OF IBM
 *             IBM CONFIDENTIAL
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION
 *
 *
 * FUNCTIONS   Provides validation and routing of Strategy 1 requests
 *             received from the OS/2 Kernel.
 *
 *
 * ENTRY POINTS:
 *
 * DEPENDENCIES:
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
 * CHANGE ACTIVITY =
 *  DATE      FLAG        APAR   CHANGE DESCRIPTION
 *  --------  ----------  -----  --------------------------------------
 *  mm/dd/yy  @Vr.mpppxx  xxxxx  xxxxxxx
 ****************************************************************************/

#include "flthdr.h"

extern USHORT InitComplete;

/****************************************************************************
 *
 * FUNCTION NAME = CD_Filter_Strat1
 *
 * DESCRIPTION   =
 *
 *
 * INPUT         = ES:BX Pointer to Request Packet
 *
 * OUTPUT        = ES:BX Pointer to Request Packet
 *
 * RETURN-NORMAL =
 *
 * RETURN-ERROR  =
 *
 ****************************************************************************/

VOID NEAR CD_Filter_Strat1()
{

 PRPH           pRPH;
 USHORT         Cmd;

 _asm
   {
     mov word ptr pRPH[0], bx
     mov word ptr pRPH[2], es
   }

   Cmd = pRPH->Cmd;
   if ( (Cmd == CMDInitBase) && !InitComplete )
   {
      pRPH->Status = CD_Filter_Init( (PRPINITIN) pRPH );
   }
   else if ((Cmd == CMDOpen) || (Cmd == CMDClose))
   {
      pRPH->Status = STDON;
   }
   else
   {
      pRPH->Status = STDON + STERR + ERROR_I24_BAD_COMMAND;
   }

  _asm
  {
     leave
     retf
  }
}

